drop table AuthorisationAdditionalTraining if exists;
drop table AuthorisationField if exists;
drop table AuthorisationFocus if exists;
drop table AuthorisedDoctor if exists;
drop table MedicalField if exists;
drop table Registrar if exists;
drop table RotationPlan if exists;
drop table RotationPlanSegment if exists;
drop table TrainingPositionField if exists;
drop table TrainingScheme if exists;
drop table TrainingSchemeSegment if exists;
drop table TrainingSite if exists;
drop table TrainingSiteDepartment if exists;
create table AuthorisationAdditionalTraining (uid bigint generated by default as identity, grantedOn timestamp, grantedTo timestamp, authorisedDoctor_uid bigint, trainingSiteDepartment_uid bigint, primary key (uid));
create table AuthorisationField (uid bigint generated by default as identity, grantedOn timestamp, grantedTo timestamp, authorisedDoctor_uid bigint, trainingSiteDepartment_uid bigint, medicalField_uid bigint, primary key (uid));
create table AuthorisationFocus (uid bigint generated by default as identity, grantedOn timestamp, grantedTo timestamp, authorisedDoctor_uid bigint, trainingSiteDepartment_uid bigint, primary key (uid));
create table AuthorisedDoctor (uid bigint generated by default as identity, birthDate date, name varchar(255) not null, lanr integer not null, primary key (uid));
create table MedicalField (uid bigint generated by default as identity, description clob, name varchar(255) not null, primary key (uid));
create table Registrar (uid bigint generated by default as identity, birthDate date, name varchar(255) not null, primary key (uid));
create table RotationPlan (uid bigint generated by default as identity, registrar_uid bigint not null, trainingScheme_uid bigint not null, primary key (uid));
create table RotationPlanSegment (uid bigint generated by default as identity, approved boolean not null, begin date not null, end date not null, fullTimeEquivalent double not null, funded boolean not null, authorisationField_uid bigint not null, rotationPlan_uid bigint not null, primary key (uid));
create table TrainingPositionField (uid bigint generated by default as identity, availableFrom timestamp, availableUntil timestamp, capacity integer not null, fullTimeEquivalent double not null, authorisationField_uid bigint, medicalField_uid bigint, primary key (uid));
create table TrainingScheme (uid bigint generated by default as identity, description clob, title varchar(255) not null, primary key (uid));
create table TrainingSchemeSegment (uid bigint generated by default as identity, duration integer not null, inpatient boolean not null, outpatient boolean not null, medicalField_uid bigint, trainingScheme_uid bigint, primary key (uid));
create table TrainingSite (uid bigint generated by default as identity, city varchar(255), name varchar(255), plz integer not null, street varchar(255), primary key (uid));
create table TrainingSiteDepartment (uid bigint generated by default as identity, treatmentType integer, medicalField_uid bigint, trainingSite_uid bigint, primary key (uid));
alter table AuthorisedDoctor add constraint UK_tnkhujxtm52xfkys9eb77k6o8 unique (lanr);
alter table MedicalField add constraint UK_ssjbeflfufjho244ofssgl11c unique (name);
alter table AuthorisationAdditionalTraining add constraint FK8u9olr1clbnj9ntjr8pua09ta foreign key (authorisedDoctor_uid) references AuthorisedDoctor;
alter table AuthorisationAdditionalTraining add constraint FKf1r40opgkjc7ltynn98ffp6v1 foreign key (trainingSiteDepartment_uid) references TrainingSiteDepartment;
alter table AuthorisationField add constraint FK3sinihmbwnaf1hfqm65g6nku8 foreign key (authorisedDoctor_uid) references AuthorisedDoctor;
alter table AuthorisationField add constraint FK6xam0l1alo7fox5qhjjfxje4j foreign key (trainingSiteDepartment_uid) references TrainingSiteDepartment;
alter table AuthorisationField add constraint FK4rd41ba0ouvj3qkaxvyksqq46 foreign key (medicalField_uid) references MedicalField;
alter table AuthorisationFocus add constraint FKm5b1bllcv1rfgsjpk6ucb2i9x foreign key (authorisedDoctor_uid) references AuthorisedDoctor;
alter table AuthorisationFocus add constraint FKdl9706bt9p0o6y3n85vgjmeq5 foreign key (trainingSiteDepartment_uid) references TrainingSiteDepartment;
alter table RotationPlan add constraint FKeq56du0s3e13prx3enaiasqf7 foreign key (registrar_uid) references Registrar;
alter table RotationPlan add constraint FK4xxmiq5cjja2t03l9yurt1n7v foreign key (trainingScheme_uid) references TrainingScheme;
alter table RotationPlanSegment add constraint FK3iew8xx401kr0l5x983oj26al foreign key (authorisationField_uid) references AuthorisationField;
alter table RotationPlanSegment add constraint FKe8sjegn5jbxobyy1cbp3vw2uu foreign key (rotationPlan_uid) references RotationPlan;
alter table TrainingPositionField add constraint FKllln05cxlstxksk72v3na4lbo foreign key (authorisationField_uid) references AuthorisationField;
alter table TrainingPositionField add constraint FKih2q44h97fyyukv70nddbilx3 foreign key (medicalField_uid) references MedicalField;
alter table TrainingSchemeSegment add constraint FKsscvvjlicdrynjjjvfy8kwo8o foreign key (medicalField_uid) references MedicalField;
alter table TrainingSchemeSegment add constraint FKjc8pwtbakwxt09eae3sddojdp foreign key (trainingScheme_uid) references TrainingScheme;
alter table TrainingSiteDepartment add constraint FKh4bys2mpvrabykrgsw8temi2g foreign key (medicalField_uid) references MedicalField;
alter table TrainingSiteDepartment add constraint FKpv27npumugjwshs8p0xpj3btu foreign key (trainingSite_uid) references TrainingSite;